
local Log, log0, log in gui.BattleLog
local min,max,ceil in math

local function min_hull_integrity(target)
  return floor(target.structure*.3)
end

local function get_hull(target)
  return target.structure-(target.structure_damage or 0)
end


local function clamp(value, min_value, max_value)
  return max(min(value, max_value), min_value)
end

local function is_space_harpy(ship)
  --kludge
  local autorepair_rate, unboardable in ship.drawer_table?
  if (autorepair_rate or 0) > 0 and unboardable
    return true
  end
end

function deal_structure_and_system_damage(damage,ship)

  local max_health = ship.structure
  local structure = max_health-ship.structure_damage
  
  local systems_damage=damage

  -- reduce structure damage according to the damage/max_health ratio
  -- this will make system damage relevant more often in combat
  local destruction_ratio = is_space_harpy(ship) and 1 or clamp(0.25*(damage*damage)/max_health, 0.2, 1.0)

  local struct_damage = ceil( damage * destruction_ratio )

  if(struct_damage>structure) 
    struct_damage=structure
  end

  log("%d structure damage (%d)",struct_damage,structure)

  -- check to see whether the implied systems damage causes the
  -- ship to explode.
  munitions_death = damage_systems(systems_damage,ship)

  if(structure<=0) 
    ship.structure_damage=max_health

    return  munitions_death or "Structural integrity" 
  else
    ship.structure_damage=ship.structure_damage+struct_damage
    structure = max_health-ship.structure_damage
    
    if( get_hull(ship) < min_hull_integrity(ship) )
      ship.structure_damage=min(ship.structure_damage,max_health)
      return munitions_death or "Structural integrity" 
    end 

  end

  return munitions_death

end